<!DOCTYPE html>
<html lang="en" class="no-js">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>Sports Data</title>
	<meta name="Description" content="NFL Data" />
	<meta name="Keywords" content="Stuff" />
	<link rel="stylesheet" type="text/css" href="fonts/font-awesome-4.7.0/css/font-awesome.min.css" media="all" />
	<link rel="stylesheet" type="text/css" href="css/bootstrap.min.css" media="screen" />
	<link rel="stylesheet" type="text/css" href="css/main.css" media="screen" />
</head>
<body>
<?php
function get_index($array, $index){
  return isset($array[$index]) ? $array[$index] : null;
}
function index_var($var){
	$value = get_index($_POST, $var) || get_index($_GET, $var)
		? get_index($_POST, $var)
			? get_index($_POST, $var)
			: get_index($_GET, $var)
		: '';
		return $value;
}
function acmp($a, $b){
    return $a['displayName'] <=> $b['displayName'];
}
function steams($a, $b){
    return $a['displayValue'] <=> $b['displayValue'];
}
?>
<?php
class jsonGames {
	public function makeTeams($json_folder,$season_type,$sport,$league){
		$file = $json_folder.'/'.$league.'/teams.json';
		switch($season_type){
			case 1 : $season_type = 'Preseason'; break;
			case 2 : $season_type = 'Regular Season'; break;
			case 3 : $season_type = 'Postseason'; break;
			case 4 : $season_type = 'Off Season'; break;
			default: $season_type = 'Regular Season'; break;
		}
		$json = 'https://site.web.api.espn.com/apis/site/v2/sports/'.$sport.'/'.$league.'/groups';
		$url = file_get_contents($json);
		$games = json_decode($url, true);
		$groups = $games['groups'];
		$arrteams = array();
		$content = '';
		foreach($groups as $g){
			$conf = $g['name'];
			$conf_abb = $g['abbreviation'];
			$content .= '<strong>'.$conf.'</strong><br/>';
			$divs= $g['children'];
			foreach($divs as $d){
				$div = $d['name'];
				$div_abb = $d['abbreviation'];
				$content .= '&nbsp;&nbsp;<strong>'.$div.'</strong><br/>';
				$teams= $d['teams'];
				//uasort($teams,'acmp');
				foreach($teams as $t){
					$id = $t['id'];
					$team = $t['displayName'];
					$team_abb = $t['abbreviation'];
					$content .= '&nbsp;&nbsp;&nbsp;&nbsp;'.$id.'. '.$team.'<br/>';
					$arr_teams['leauge'] = $conf;
					$arr_teams['leauge_abb'] = $conf_abb;
					$arr_teams['division'] = $div;
					$arr_teams['division_abb'] = $div_abb;
					$arr_teams['id'] = $id;
					$arr_teams['team'] = $team;
					$arr_teams['team_abb'] = $team_abb;
					$arr_teams['w'] = "0";
					$arr_teams['l'] = "0";
					if($league != 'nhl' && $league != 'nba'){
						$arr_teams['t'] = "0";
					}
					if($league != 'nhl'){
						$arr_teams['pct'] = "0.000";
					}
					if($league == 'nhl'){
						$arr_teams['pts'] = "0";
						$arr_teams['otl'] = "0";
					}
					array_push( $arrteams, $arr_teams );
				}
			}
		}
		//echo $content;
		$make_json = json_encode($arrteams, JSON_FORCE_OBJECT);
		file_put_contents($file, $make_json); // uncomment to run.
	}
	public function teams($json_folder,$season_type,$sport,$league,$run=NULL){
		$file = $json_folder.'/'.$league.'/teams.json';
		if(!file_exists($file)) $this->makeTeams($json_folder,$season_type,$sport,$league);
		$standings = 'https://site.api.espn.com/apis/v2/sports/'.$sport.'/'.$league.'/standings';
		$get_standings = file_get_contents($standings);
		$games = json_decode($get_standings, true);
		$cnt = $games['children'][0]['standings']['entries'];
		$cnt_games = count($cnt);
		$this->teams_update($games,$file,$league,0,$cnt_games,$run);
		$this->teams_update($games,$file,$league,1,$cnt_games,$run);
	}
	public function teams_update($games,$file,$league,$con,$c,$run){
		$write_json = file_get_contents($file);
		$write_arr = json_decode($write_json, true);
		for($i=0; $i<$c; $i++){
			$team = $games['children'][$con]['standings']['entries'][$i]['team'];
			$team_id = $team['id'];
			$team_name = $team['displayName'];
			$stats = $games['children'][$con]['standings']['entries'][$i]['stats'];
			$w = $stats[1]['displayValue'];
			$l = $stats[2]['displayValue'];
			if($league != 'nhl'){
				$t = $stats[5]['displayValue'];
				$pct = $stats[3]['value'];
				$pct = number_format($pct, 3, '.', '');
			}
			if($league == 'nhl'){
				$pts = $stats[6]['displayValue'];
				$otl = $stats[10]['displayValue'];
			}
			//uasort($stats,'steams');
			if($write_arr){
				$c_json = count($write_arr);
				for($it=0;$it<$c_json;$it++){
					if($team_id == $write_arr[$it]['id']){
						$write_arr[$it]['w'] = $w;
						$write_arr[$it]['l'] = $l;
						if($league != 'nhl' && $league != 'nba'){
							$write_arr[$it]['t'] = $t;
						}
						if($league != 'nhl'){
							$write_arr[$it]['pct'] = $pct;
						}
						if($league == 'nhl'){
							$write_arr[$it]['otl'] = $otl;
							$write_arr[$it]['pts'] = $pts;
						}
						echo $team_name.' W '.$w.' L '.$l.' ';
						if($league != 'nhl' && $league != 'nba') echo 'T '.$t.' ';
						if($league != 'nhl') echo 'Pct '.$pct.' ';
						if($league == 'nhl') echo 'Pts '.$pts.' OTL '.$otl.'';
						echo '<br/>';
					}
				}
				
			}
		}
		if($write_arr){
			$new = json_encode($write_arr, JSON_FORCE_OBJECT);
			if($run) file_put_contents($file, $new);
		}
	}
	public function makeDates($json_folder,$sport, $league,$season_type=NULL){
		switch($season_type){
			case 1 : $dates_json = 'pre'; break;
			case 2 : $dates_json = 'reg'; break;
			case 3 : $dates_json = 'post'; break;
			case 4 : $dates_json = 'off'; break;
			default: $dates_json = 'reg'; break;
		}
		$file = $json_folder.'/'.$league.'/dates_'.$dates_json.'.json';
		$path = $sport.'/'.$league;
		$events = 'http://site.api.espn.com/apis/site/v2/sports/'.$path.'/scoreboard';
		$url = file_get_contents($events);
		$list = json_decode($url,true);
		$all_dates = $list['leagues'][0]['calendar'];
		$cnt_all = count($all_dates);

		$in = array('T','Z');
		$out = array(' ','');
		$arrdates = array();
		if($league != 'nfl' && $sport != 'soccer'){
			switch($season_type){
				case 1 : $season_type = 'Preseason'; break;
				case 2 : $season_type = 'Regular Season'; break;
				case 3 : $season_type = 'Postseason'; break;
				case 4 : $season_type = 'Off Season'; break;
				case NULL : $season_type = 'Regular Season'; break;
				default: $season_type = 'Regular Season'; break;
			}
			$json = "https://sports.core.api.espn.com/v2/sports/$sport/leagues/$league/calendar/whitelist";
			$url = file_get_contents($json);
			$games = json_decode($url, true);

			$season = $games['sections'];
			$date = $games['eventDate']['dates'];
			$seasons = count($season);
			$in = array('T','Z');
			$out = array(' ',':00');
			for($i = 0; $i < $seasons; $i++){
				$season_name = $season[$i]['label'];
				if($season_name == $season_type){
					$start = $season[$i]['startDate'];
					$end = $season[$i]['endDate'];
					$start = str_ireplace($in,$out,$start);
					$end = str_ireplace($in,$out,$end);
				};
			}
			foreach($date as $v=>$k){
				$k = str_ireplace($in,$out,$k);
				if($k >= $start && $k <= $end){
					$date = date('Y-m-d', strtotime($k));
					$arr_dates['date'] = $date;
					array_push( $arrdates, $arr_dates );
				}
			}
		}else if($league == 'nfl'){
			foreach( $all_dates as $d ){
				$value = $d['value'];
				if($value == $season_type){
					$start_date = $d['startDate'];
					$end_date = $d['endDate'];
					$entries = $d['entries'];
					foreach( $entries as $de ){
						$name = $de['label'];
						$week = $de['value'];
						$start_week = $de['startDate'];
						$end_week = $de['endDate'];
						$start_week = ''.str_ireplace($in, $out, $start_week);
						$start_week = date('Ymd', strtotime($start_week));
						$end_week = ''.str_ireplace($in, $out, $end_week);
						$end_week = date('Ymd', strtotime($end_week));
						$arr_dates['week'] = $week;
						$arr_dates['start'] = $start_week;
						$arr_dates['end'] = $end_week;
						array_push( $arrdates, $arr_dates );
					}
				}
			}
		}else{
			$start_date = $list['leagues'][0]['calendarStartDate'];
			$end_date = $list['leagues'][0]['calendarEndDate'];
			for($i = 0; $i < $cnt_all; $i++){
				$date = $all_dates[$i];
				$date = ''.str_ireplace($in, $out, $date);
				$date = date('Y-m-d', strtotime($date));
				$arr_dates['date'] = $date;
				array_push( $arrdates, $arr_dates );
			}
		}
		$make_dates = json_encode($arrdates, JSON_FORCE_OBJECT);
		file_put_contents($file, $make_dates);
	}
	public function season_update($json_folder,$sport,$league,$get_date,$season_type=NULL){
		switch($season_type){
			case 1 : $dates_json = 'pre'; break;
			case 2 : $dates_json = 'reg'; break;
			case 3 : $dates_json = 'post'; break;
			case 4 : $dates_json = 'off'; break;
			default: $dates_json = 'reg'; break;
		}
		$json_date = $json_folder.'/'.$league.'/dates_'.$dates_json.'.json';
		$json_season = $json_folder.'/'.$league.'/season_'.$dates_json.'.json';
		if(!is_dir($json_folder.'/'.$league)) mkdir($json_folder.'/'.$league);
		if(!file_exists($json_date)) $this->makeDates($json_folder,$sport, $league,$season_type);
		$get_dates = file_get_contents($json_date);
		$get_dates = json_decode($get_dates,true);
		// make/get season
		if(!file_exists($json_season)){
			$write_arr = array();
		}else{
			$write_json = file_get_contents($json_season);
			$write_arr = json_decode($write_json, true);
		}
		$path = $sport.'/'.$league;
		if(isset($get_dates[0]['week'])){
			$first =  date('n', strtotime($get_dates[0]['start']));
		}else{
			$first = date('n', strtotime($get_dates[0]['date']));
		}
		$date_display = '';
		$show = '';
		$notes = '';
		foreach($get_dates as $key=>$value){
			$week = isset($value['week']);
			$date = isset($value['date']);
			$goto_date = isset($value['week'])
				? isset($value['week']) && $value['week'] == $get_date
				: isset($value['date']) && $value['date'] == $get_date;
			if(!$get_date) $goto_date = isset($key);
			if($goto_date){
				if(isset($value['week'])){
					$days = $value['week'];
					$first_of_week = $value['start'];
					$last_of_week = $value['end'];
					$dates = $first_of_week.'-'.$last_of_week;
					$and = '?week='.$days;
					$date_display = '&nbsp;&nbsp;<strong>Week '.$days.'</strong><br/>';
					echo $date_display;
				}else{
					$days = $value['date'];
					$dates = $days;
					$date = str_ireplace('-','',$days);
					$year = date('Y', strtotime($dates));
					$and = '?dates='.$date;
					$display = date('l F jS, Y', strtotime($date));
					$date_display = '&nbsp;&nbsp;<strong>'.$display.'</strong><br/>';
					echo $date_display;
				}
				
				$day = 'http://site.api.espn.com/apis/site/v2/sports/'.$path.'/scoreboard'.$and;
				if(file_exists($day))
					continue;
				$json = file_get_contents($day);
				$get = json_decode($json,true);
				$get_events = $get['events'];
				$cnt_events = count($get_events);
				$state = '';
				for($d = 0; $d < $cnt_events; $d++){
					$in = array(' at',' EDT',' EST','T','Z');
					$out = array('','','',' ','');
					$gid = $get_events[$d]['id'];
					$get_edate = $get_events[$d]['date'];
					$edate = $get_events[$d]['date'];
					$edate = str_ireplace($in,$out,$edate);
					$year = date('Y', strtotime($edate));
					$state = $get_events[$d]['status']['type']['state'];
					$detail = $get_events[$d]['status']['type']['detail'];
					$short_detail = $get_events[$d]['status']['type']['shortDetail'];
					if(!isset($value['week'])){
						if($short_detail != 'TBD' && $short_detail != 'TBC' && $state == 'pre'){
							$date = str_ireplace($in,$out,$short_detail);
							list($nada,$etime) = explode(" - ",$date);
							list($time,$ap) = explode(" ",$etime);
							$date_time = $ap = 'PM'
								? date('H:m:s', strtotime($time.' + 12 hours'))
								: date('H:m:s', strtotime($time));
							$date = $dates.' '.$date_time;
							$display_date = date('g:i a', strtotime($date));
						}else{
							$display_date = date('D M jS, Y', strtotime($dates));
							$display_date = $state == 'post' || $state == 'in'
								? '<i>'.$short_detail.'</i>'
								: '<i>'.$display_date.' '.$short_detail.'</i>';
							$date = $dates;
						}
					}else{
						if($short_detail != 'TBD' && $short_detail != 'TBC' && $state == 'pre'){
							$date = str_ireplace($in,$out,$short_detail);
							list($edate,$etime) = explode(" - ",$date);
							$i = array('/',' - ');
							$o = array('-','-');
							$edate = str_ireplace($i,$o,$edate);
							list($time,$ap) = explode(" ",$etime);
							
							$date_time = $ap = 'PM'
								? date('H:m:s', strtotime($time.' + 12 hours'))
								: date('H:m:s', strtotime($time));
							$date = $year.'-'.$edate.' '.$date_time;
							$display_date = $date;
							$date = date('Y-m-d H:m:s', strtotime($date));
							$display_date = date('D M jS, Y g:i a', strtotime($date));
						}else{
							list($dates,$ap) = explode(" ",$edate);
							$display_date = date('D M jS, Y', strtotime($dates));
							$display_date = $state == 'post' || $state == 'in'
								? '<i>'.$short_detail.'</i>'
								: '<i>'.$display_date.' '.$short_detail.'</i>';
							$date = $dates;
						}
					}
					$display_day = date('D', strtotime($dates));
					$date = $state == 'pre'
						? $date
						: $dates;
					$display_day = $state == 'pre'
						? $display_day
						: '';
					$name = isset($get_events[$d]['shortName'])
						? $get_events[$d]['shortName']
						: '';
					$notes = isset($get_events[$d]['competitions'][0]['notes'][0]['headline'])
						? $get_events[$d]['competitions'][0]['notes'][0]['headline']
						: '';
					$home = $get_events[$d]['competitions'][0]['competitors'][0]['team']['displayName'];
					$home_score = isset($get_events[$d]['competitions'][0]['competitors'][0]['score'])
						? $get_events[$d]['competitions'][0]['competitors'][0]['score']
						: '';
					$away = $get_events[$d]['competitions'][0]['competitors'][1]['team']['displayName'];
					$away_score = isset($get_events[$d]['competitions'][0]['competitors'][1]['score'])
						? $get_events[$d]['competitions'][0]['competitors'][1]['score']
						: '';
					switch($state){
						case 'in' : $status = '  class="pending"'; break;
						case 'post' : $status = ' class="green"'; break;
						case 'pre' : $status = ''; break;
						default: $status = '';
					}
					if(!file_exists($json_season)){
						$arreid['id'] = $gid;
						if($league == 'nfl'){
							$arreid['week'] = $days;
							$arreid['date'] = $date;
						}else{
							$arreid['date'] = $date;
						}
						$arreid['teams'] = $name;
						$arreid['home'] = $home;
						$arreid['home_score'] = $home_score;
						$arreid['away'] = $away;
						$arreid['away_score'] = $away_score;
						array_push( $write_arr, $arreid );
					}else{
						if($write_arr){
							$cnt_arr = count($write_arr);
							for($it=0;$it<$cnt_arr;$it++){
								if($gid == $write_arr[$it]['id']){
									if($state == 'pre'){
										$write_arr[$it]['date'] = $date;
										$write_arr[$it]['teams'] = $name;
										$write_arr[$it]['away'] = $away;
										$write_arr[$it]['home'] = $home;
									}
									$write_arr[$it]['home_score'] = $home_score;
									$write_arr[$it]['away_score'] = $away_score;
								}
							}
						}
					}
					$away_score = $state == 'pre'
						?  ''
						 :' <b>'.$away_score.'</b> ';
					$home_score = $state == 'pre'
						? ''
						 :' <b>'.$home_score.'</b> ';
					if($state == 'post'){
						$display_end = ' ('.$display_date.')';
						$display_date = '';
					}else{
						$display_end = '';
						$display_date = '('.$display_date.') ';
					}
					echo '<div'.$status.'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.$display_date.$away.' '.$away_score.'@'.$home_score.' '.$home.$display_end. '</div>';
					if($notes) echo '<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.$notes.'</div>';
				}
			}
		}
		$make_json = json_encode($write_arr, JSON_FORCE_OBJECT);  
		file_put_contents($json_season, $make_json);
	}
	public function dateSelect($file,$league,$select=NULL){
		$json = file_get_contents($file);
		$dates = json_decode($json,true);
		echo '<select class="date-select">'."\n";
		foreach($dates as $key=>$value){
			$week = isset($value['week']);
			$date = isset($value['date']);
			if($week) $val = $value['week'];
			if($date) $val = $value['date'];
			echo '<option value ="'.$val.'"';
			if($select == $val) echo ' selected="selected"';
			echo '>';
			$val = $league == 'nfl'
				? 'Week '.$val
				: ''.date('D M jS Y', strtotime($val));
			echo ''.$val.'';
			echo '</option>'."\n";
		}
		echo '</select>'."\n";
	}
	public function sportSelect($file,$league,$select=NULL){
		$json = file_get_contents($file);
		$dates = json_decode($json,true);
		echo '<select class="date-select">'."\n";
		foreach($dates as $key=>$value){
			$week = isset($value['week']);
			$date = isset($value['date']);
			if($week) $val = $value['week'];
			if($date) $val = $value['date'];
			echo '<option value ="'.$val.'"';
			if($select == $val) echo ' selected="selected"';
			echo '>';
			$val = $league == 'nfl'
				? 'Week '.$val
				: ''.date('D M jS Y', strtotime($val));
			echo ''.$val.'';
			echo '</option>'."\n";
		}
		echo '</select>'."\n";
	}
}
$jsonGames= new jsonGames();
/*
$sport = 'football';
$league = 'nfl';
$sport = 'soccer';
$league = 'eng.1';
$league = 'esp.1';
$league = 'usa.1';
$league = 'ita.1';
$sport = 'baseball';
$league = 'mlb';
$sport = 'basketball';
$league = 'nba';
$league = 'wnba';
*/

$sport = 'soccer';
$league = 'usa.1';

$json_folder = 'json-leagues';

/*$sport = index_var('sport')
	? index_var('sport')
	: index_var('sport');*/

$day = 'http://site.api.espn.com/apis/site/v2/sports/'.$sport.'/'.$league.'/scoreboard';
$get = file_get_contents($day);
$get = json_decode($get,true);
$season_type = $get['season']['type'];
$date = isset($get['week']['number'])
	? $get['week']['number']
	: $get['day']['date'];
switch($season_type){
	case 1 : $dates_json = 'pre'; break;
	case 2 : $dates_json = 'reg'; break;
	case 3 : $dates_json = 'post'; break;
	case 4 : $dates_json = 'off'; break;
	default: $dates_json = 'reg'; break;
}
$file = $json_folder.'/'.$league.'/dates_'.$dates_json.'.json';

switch($season_type){
	case 1 : $season = 'Preseason'; break;
	case 2 : $season = 'Regular Season'; break;
	case 3 : $season = 'Postseason'; break;
	case 4 : $season = 'Off Season'; break;
	default: $season = ''; break;
}
if(file_exists($file)){
	$get_dates = file_get_contents($file);
	$get_dates = json_decode($get_dates,true);
	$cnt = count($get_dates);
	$date = isset($get_dates[$cnt - 1]['date']) && ($get_dates[$cnt - 1]['date'] < $date)
		? $get_dates[$cnt - 1]['date']
		: $date;
}

$date = !index_var('date')
	? $date
	: index_var('date');
$run = 1;
if(file_exists($file)){
	$jsonGames->dateSelect($file,$league,$date); echo $season;
}else{
	$date = NULL;
}
echo '<div class="wrapper">';
echo '<div class="wrapper-reload">';
$jsonGames->season_update($json_folder,$sport,$league,$date,$season_type);
//$jsonGames->teams($json_folder,$season_type,$sport,$league,$run);
echo '</div>'."\n";
echo '</div>'."\n";
?>
<script type="text/javascript" src="js/jquery-3.4.1.min.js"></script>
<script type="text/javascript" src="js/bootstrap.min.js"></script>
<script>
$(document).on("change input propertychange", ".date-select", function(e){
	$val = $(this).val();
	$('.wrapper').load(document.URL + '?date=' + $val + ' .wrapper-reload');
});
</script>
</body>
</html>